Unit AER19R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AER19R(NM :Integer; N :Integer; var A :Array of Real;
                var D :Array of Real; var E :Array of Real;
                var Z :Array of Real);

implementation

procedure AER19R(NM :Integer; N :Integer; var A :Array of Real;
                var D :Array of Real; var E :Array of Real;
                var Z :Array of Real);
var
I,J,K,L,II,JP1 :Integer;
F,G,H,HH,SCALE :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18;
begin
for I:=1 to N do
 begin
  for J:=1 to I do
   begin
    Z[(I-1)+(J-1)*NM] := A[(I-1)+(J-1)*NM];
_1:
   end;
 end;
if ( N = 1 ) 
 then goto _13;
{  ********** }
for II:=2 to N do
 begin
  I := N+2-II;
  L := I-1;
  H := 0.0;
  SCALE := 0.0;
  if ( L < 2 ) 
   then goto _3;
{  ********** }
  for K:=1 to L do
   begin
_2:
    SCALE := SCALE+Abs(Z[(I-1)+(K-1)*NM]);
   end;
  if ( SCALE <> 0.0 ) 
   then goto _4;
_3:
  E[I-1] := Z[(I-1)+(L-1)*NM];
  goto _11;
_4:
  for K:=1 to L do
   begin
    Z[(I-1)+(K-1)*NM] := Z[(I-1)+(K-1)*NM]/SCALE;
    H := H+Z[(I-1)+(K-1)*NM]*Z[(I-1)+(K-1)*NM];
_5:
   end;
  F := Z[(I-1)+(L-1)*NM];
  G := -Sign(Sqrt(H),F);
  E[I-1] := SCALE*G;
  H := H-F*G;
  Z[(I-1)+(L-1)*NM] := F-G;
  F := 0.0;
  for J:=1 to L do
   begin
    Z[(J-1)+(I-1)*NM] := Z[(I-1)+(J-1)*NM]/H;
    G := 0.0;
{  ********** }
    for K:=1 to J do
     begin
_6:
      G := G+Z[(J-1)+(K-1)*NM]*Z[(I-1)+(K-1)*NM];
     end;
    JP1 := J+1;
    if ( L < JP1 ) 
     then goto _8;
    for K:=JP1 to L do
     begin
_7:
      G := G+Z[(K-1)+(J-1)*NM]*Z[(I-1)+(K-1)*NM];
     end;
{  ********** }
_8:
    E[J-1] := G/H;
    F := F+E[J-1]*Z[(I-1)+(J-1)*NM];
_9:
   end;
  HH := F/(H+H);
{  ********** }
  for J:=1 to L do
   begin
    F := Z[(I-1)+(J-1)*NM];
    G := E[J-1]-HH*F;
    E[J-1] := G;
    for K:=1 to J do
     begin
      Z[(J-1)+(K-1)*NM] := Z[(J-1)+(K-1)*NM]-F*E[K-1]-G*Z[(I-1)+(K-1)*NM];
_10:
     end;
   end;
_11:
  D[I-1] := H;
_12:
 end;
_13:
D[0] := 0.0;
E[0] := 0.0;
{  ********** }
for I:=1 to N do
 begin
  L := I-1;
  if ( D[I-1] = 0.0 ) 
   then goto _16;
  for J:=1 to L do
   begin
    G := 0.0;
    for K:=1 to L do
     begin
_14:
      G := G+Z[(I-1)+(K-1)*NM]*Z[(K-1)+(J-1)*NM];
     end;
    for K:=1 to L do
     begin
      Z[(K-1)+(J-1)*NM] := Z[(K-1)+(J-1)*NM]-G*Z[(K-1)+(I-1)*NM];
_15:
     end;
   end;
_16:
  D[I-1] := Z[(I-1)+(I-1)*NM];
  Z[(I-1)+(I-1)*NM] := 1.0;
  if ( L < 1 ) 
   then goto _18;
  for J:=1 to L do
   begin
    Z[(I-1)+(J-1)*NM] := 0.0;
    Z[(J-1)+(I-1)*NM] := 0.0;
_17:
   end;
_18:
 end;
end;

end.
