Unit AGH8R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AER13R_p, AER19R_p, AER15R_p, AER11R_p, UTAG10_p;

procedure AGH8R(var A :Array of Real; var B :Array of Real;
                var V :Array of Real; var EV :Array of Real;
                var RAB1 :Array of Real; N :Integer;
                var IERR :Integer);

implementation

procedure AGH8R(var A :Array of Real; var B :Array of Real;
                var V :Array of Real; var EV :Array of Real;
                var RAB1 :Array of Real; N :Integer;
                var IERR :Integer);
var
N1 :Integer;
label
_1;
begin
__.elm1 := N;
N1 := N+1;
AER13R(N,N,A,B,RAB1,IERR);
if ( IERR <> 0 ) 
 then goto _1;
AER19R(N,N,A,EV,RAB1[N1-1],V);
AER15R(N,N,EV,RAB1[N1-1],V,IERR);
if ( IERR <> 0 ) 
 then goto _1;
AER11R(N,N,B,RAB1,N,V);
_1:
if ( IERR <> 0 ) 
 then UTAG10(IERR,54);
end;

end.
